# Dagger: Dota 2 Stats

Dagger is an Android app that keeps you up-to-date with the latest Dota 2 matches, it also is ad-free and open source.

Data is collected through the [OpenDota's](https://www.opendota.com) API and [Dota 2](https://www.dota2.com) web API.

## Screenshots
<img src="assets/screen1.png" width="150"> <img src="assets/screen2.png" width="150" > <img src="assets/screen3.png" width="150"> <img src="assets/screen4.png" width="150">   

<img src="assets/screen5.png" width="150"> <img src="assets/screen6.png" width="150"> <img src="assets/screen7.png" width="150"> <img src="assets/screen8.png" width="150">

## Features
- Offline support
- Search players
- Bookmark players
- Bookmark matches
- Add notes to bookmarked matches
- Match history for any player
- Match summary
- Player performance comparison
- Leaderboards
- Competitive matches
- Live Twitch streams
- Search history

## Libraries
- [Android Architecture Components](https://developer.android.com/arch)
- [Retrofit](https://github.com/square/retrofit) for REST api communication
- [Coroutines](https://kotlinlang.org/docs/reference/coroutines.html) for writing asynchronous code
- [Coil](https://github.com/coil-kt/coil) for image loading
- [Dagger 2](https://github.com/google/dagger) for dependency injection
- [SQLDelight](https://github.com/cashapp/sqldelight) for database access

## Notes
- Dota 2 is a registered trademark of Valve Corporation.

## Download

[<img src="https://fdroid.gitlab.io/artwork/badge/get-it-on.png"
     alt="Get it on F-Droid"
     height="80">](https://f-droid.org/packages/com.nikola.jakshic.dagger/)
[<img src="https://play.google.com/intl/en_us/badges/images/generic/en-play-badge.png"
     alt="Get it on Google Play"
     height="80">](https://play.google.com/store/apps/details?id=com.nikola.jakshic.dagger)

## License
    MIT License

    Copyright (c) 2022 Nikola Jakšić

    Permission is hereby granted, free of charge, to any person obtaining a copy
    of this software and associated documentation files (the "Software"), to deal
    in the Software without restriction, including without limitation the rights
    to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    copies of the Software, and to permit persons to whom the Software is
    furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice shall be included in all
    copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    SOFTWARE.
